<script lang="ts">
import Vue from 'vue';
import { PullQuote } from '../common/index.vue';

export default Vue.extend({
  name: 'EnterpriseHighlights',
  components: {
    PullQuote,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      dynamicMargins: [],
    };
  },
  mounted() {
    this.calcuateMargins();
    window.addEventListener('resize', this.calcuateMargins);
  },
  destroyed() {
    window.removeEventListener('resize', this.calcuateMargins);
  },

  methods: {
    // This method is calculating the margin needed for the bottom of the cards as there is an absolutely positioned element that can have different height depending on the content.
    calcuateMargins(): void {
      this.dynamicMargins = (this as any).$refs.highlights?.map(
        (highlight: any) => {
          const offsetTop = 100;
          if (window.innerWidth <= 1024) {
            return `${highlight.offsetHeight - offsetTop + 76}px`;
          }
          return `${highlight.offsetHeight - offsetTop}px`;
        },
      );
    },
  },
});
</script>

<template>
  <section class="customer-highlights">
    <div v-if="data.highlighted_customer" class="main-highlight">
      <img
        class="highlight__logo"
        :src="data.highlighted_customer.logo"
        alt=""
        loading="lazy"
      />
      <img
        class="main-highlight__image"
        :src="data.highlighted_customer.image.image_url"
        :alt="data.highlighted_customer.image.alt"
        loading="lazy"
      />
      <a
        class="highlight__link"
        :href="data.highlighted_customer.url"
        :data-ga-name="data.highlighted_customer.data_ga_name"
        :data-ga-location="data.highlighted_customer.data_ga_location"
        target="_blank"
      >
        <div
          v-if="data.highlighted_customer.pull_quote"
          class="main-highlight__quote_card"
        >
          <pull-quote :data="data.highlighted_customer.pull_quote" />
        </div>
        <div v-else class="main-highlight__card">
          <SlpTypography
            tag="h3"
            variant="heading4-bold"
            class="slp-mb-16"
            :class="{ font_lg__impact: data.font_variant === 'lg' }"
          >
            <span v-if="data.highlighted_customer.name">
              {{ data.highlighted_customer.name }}</span
            >
            {{ data.highlighted_customer.impact }}
          </SlpTypography>
          <ul>
            <li
              v-for="stat in data.highlighted_customer.stats"
              :key="stat.qualifier"
              class="slp-flex slp-align-items-center slp-mb-8"
            >
              <img :src="stat.icon" alt="" loading="lazy" />
              <p
                class="slp-ml-16"
                :class="{ font_lg__qualifiers: data.font_variant === 'lg' }"
              >
                <span class="highlight__bold">{{ stat.quantifier }}</span>
                {{ stat.qualifier }}
              </p>
            </li>
          </ul>
        </div>
      </a>
    </div>
    <SlpRow>
      <div
        v-for="(customer, customerIndex) in data.customers"
        :key="customer.name"
        size="lg"
        :col="2"
        class="highlight"
        :style="{ marginBottom: dynamicMargins[customerIndex] }"
      >
        <div class="shadow_overlay">
          <img
            class="highlight__logo"
            :src="customer.logo"
            :alt="customer.logo_alt ? customer.logo_alt : ''"
            loading="lazy"
          />
        </div>
        <img
          class="highlight__image"
          :src="customer.image.image_url"
          :alt="customer.image.alt"
          loading="lazy"
        />
        <a
          class="highlight__link"
          :href="customer.url"
          :data-ga-name="customer.data_ga_name"
          :data-ga-location="customer.data_ga_location"
          target="_blank"
        >
          <div
            ref="highlights"
            :class="{
              font_lg__impact: data.font_variant === 'lg',
              'slp-text-lg': !data.font_variant,
            }"
            class="highlight__card"
          >
            <img
              v-if="customer && customer.icon"
              class="highlight__icon"
              :src="customer.icon"
              alt=""
              loading="lazy"
            />
            <SlpTypography tag="h3" variant="heading4-bold" class="slp-mb-8">
              {{ customer.name }} {{ customer.impact }}
            </SlpTypography>

            <ul class="slp-flex highlight__stats">
              <li
                v-for="stat in customer.stats"
                :key="stat.qualifier"
                :class="{ font_lg__impact: data.font_variant === 'lg' }"
                class="slp-flex slp-align-items-center slp-mt-8"
              >
                <p>
                  <span class="highlight__bold">{{ stat.quantifier }}</span>
                  {{ stat.qualifier }}
                </p>
              </li>
            </ul>
          </div>
        </a>
      </div>
    </SlpRow>
  </section>
</template>

<style lang="scss" scoped>
.shadow_overlay {
  width: 100%;
  height: 100px;
  display: block;
  border-radius: 8px;
  position: absolute;
  background: linear-gradient(
    180deg,
    rgba(0, 0, 0, 0.5) 0%,
    rgba(255, 255, 255, 0) 99.98%,
    rgba(255, 255, 255, 0.04) 99.99%,
    rgba(255, 255, 255, 0) 100%
  );
}

.customer-highlights {
  position: relative;
  z-index: 1;
  max-width: 1170px;
  padding: 0;
  margin-left: auto;
  margin-right: auto;
}

.font_lg {
  &__impact {
    h4 {
      font-size: 32px;
      line-height: 36px;
    }
  }

  &__qualifiers {
    font-size: 19px;
    line-height: 24px;
  }
}

.main-highlight {
  position: relative;

  img.highlight__image {
    width: 100%;
    border-radius: 8px;

    @media (max-width: $breakpoint-lg) {
      border-radius: 0;
    }
  }

  @media (max-width: $breakpoint-lg) {
    margin-bottom: 17rem;
  }

  &__card {
    background-color: $color-surface-50;
    padding: $spacing-64;
    position: absolute;
    top: 100px;
    right: 100px;
    max-width: 50%;
    border-radius: 3px;

    &:hover {
      box-shadow: 0 2px 50px rgba(0, 0, 0, 0.08);
    }

    @media (max-width: $breakpoint-lg) {
      max-width: 90%;
      left: 10%;
      top: initial;
      bottom: -60px;
      padding: $spacing-32 $spacing-16 $spacing-16 $spacing-16;
    }

    @media (max-width: $breakpoint-md) {
      max-width: 90%;
      bottom: -180px;
      left: 5%;
      right: 0;

      h4 {
        font-size: 19px;
      }
    }
  }

  &__quote_card {
    position: absolute;
    top: 100px;
    right: 32px;
    max-width: 693px;
    border-radius: 4px;

    &:hover {
      box-shadow: 0 2px 50px rgba(0, 0, 0, 0.08);
    }

    @media (max-width: $breakpoint-lg) {
      max-width: 90%;
      left: 5%;
      top: 70%;
      right: unset;
    }

    @media (max-width: $breakpoint-sm) {
      max-width: 100%;
      left: unset;
      margin-left: $spacing-16;
      margin-right: $spacing-16;
    }
  }
}

.highlight {
  position: relative;
  margin-left: $spacing-8;
  width: calc(50% - 16px);

  @media (max-width: $breakpoint-lg) {
    width: 100%;
  }

  &__bold {
    font-weight: 600;
  }

  img.highlight__image {
    width: 100%;
    max-height: 100%;
    object-fit: contain;
    @media (max-width: $breakpoint-md) {
      border-radius: 0;
    }
  }

  &__link {
    color: $color-text-300;
  }

  &__logo {
    position: absolute;
    max-width: 200px;
    top: 35px;
    left: 35px;
    filter: brightness(0) invert(1);

    @media (max-width: $breakpoint-md) {
      max-width: 100px;
      z-index: 1;
    }
  }

  &__icon {
    position: absolute;
    top: -$spacing-16;
    left: $spacing-16;
  }

  &__link {
    color: $color-text-300;
  }

  &__stats {
    flex-direction: row;
    flex-wrap: wrap;
    justify-content: space-evenly;
    li {
      width: 50%;
      padding-right: 32px;
    }
  }

  &__card {
    background-color: $color-surface-50;
    padding: $spacing-32;
    position: absolute;
    max-width: 90%;
    top: 280px;
    min-height: 225px;
    left: 5%;
    border-radius: 4px;
    box-shadow: 0 2px 50px rgba(0, 0, 0, 0.08);

    &:hover {
      box-shadow: 0 2px 50px rgba(0, 0, 0, 0.08);
    }

    @media (max-width: $breakpoint-lg) {
      font-size: 19px;
      top: 80%;
      width: 100%;
    }

    @media (max-width: $breakpoint-md) {
      h4 {
        font-size: 19px;
      }
    }

    @media (max-width: $breakpoint-sm) {
      left: unset;
      margin-left: $spacing-16;
      margin-right: $spacing-16;
    }
  }
}
</style>
